type 'a t = private {
  l : 'a list;
  r : 'a list;
  ll : int;
  lr : int;
}

type where_add = [ `Beginning | `End | `Before | `After | `Here | `At of int ]
type where_remove = [ `Before | `After ]

exception End_of_zipper

val empty : 'a t
val next : 'a t -> 'a t
val previous : 'a t -> 'a t
val first : 'a t -> 'a t
val last : 'a t -> 'a t
val add : where_add -> 'a t -> 'a -> 'a t
val pos : 'a t -> int
val length : 'a t -> int
val get : 'a t -> 'a
val set : 'a t -> 'a -> 'a t
val nth : 'a t -> int -> 'a t
val remove : where_remove -> 'a t -> 'a t
val remove_nth : 'a t -> int -> 'a t
val move : 'a t -> int -> int -> 'a t
val find : ('a t -> bool) -> 'a t -> 'a t

